//DefractionGun.cs

//audio
datablock AudioProfile(DefractionGunShotSound)
{
   filename    = "./LaserShotgun.wav";
   description = AudioClose3d;
   preload = true;
};


//trail
datablock ParticleData(DefractionGunTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 60;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "1 1 0.0 1";
	colors[1]	= "1 .8 0.0 0.4";
	sizes[0]	= 0.15;
	sizes[1]	= 0.25;
	//times[0]	= 0.5;
	//times[1]	= 0.5;
};

datablock ParticleEmitterData(DefractionGunTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = DefractionGunTrailParticle;

   useEmitterColors = true;
   uiName = "";
};

//muzzle flash effects
datablock ParticleData(DefractionGunFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.5 0.4 0.0 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(DefractionGunFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "DefractionGunFlashParticle";

   uiName = "";
};


datablock ExplosionData(DefractionGunExplosion)
{
   //explosionShape = "";
	soundProfile = LaserHitSound;

   lifeTimeMS = 150;

   particleEmitter = LaserExplosionEmitter;
   particleDensity = 9;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 2;
   lightStartColor = "0.9 0.8 0.0";
   lightEndColor = "0 0 0";
};


AddDamageType("DefractionGun",   '<bitmap:add-ons/Weapon_DefractionGun/CI_DefractionGun> %1',    '%2 <bitmap:add-ons/Weapon_DefractionGun/CI_DefractionGun> %1',0.2,1);
datablock ProjectileData(DefractionGunProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 14;
   directDamageType    = $DamageType::DefractionGun;
   radiusDamageType    = $DamageType::DefractionGun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 3;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 4;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 200;
   verticalImpulse	  = 200;
   explosion           = DefractionGunExplosion;
   particleEmitter     = DefractionGunTrailEmitter;

   muzzleVelocity      = 80;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = True;
   lightRadius = 4.0;
   lightColor  = ".75 0.7 0";

   uiName = "Defraction Gun Laser";
};

//////////
// item //
//////////
datablock ItemData(DefractionGunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./DefractionGun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Defraction Gun";
	iconName = "./icon_DefractionGun";
	doColorShift = false;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = DefractionGunImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(DefractionGunImage)
{
   // Basic Item properties
   shapeFile = "./DefractionGun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = DefractionGunProjectile;
   projectileType = Projectile;
   minShotTime = 2500;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = False;
   colorShiftColor = DefractionGunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 1.5;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "altFire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= DefractionGunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= DefractionGunShotSound;

	stateName[3]			= "Reload";
	stateTransitionOnTriggerUp[3]     = "Ready";
	stateSequence[3]	= "Ready";

};

function DefractionGunImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);

	if(%obj.getImageAmmo(%slot))
	{
		%projectile = DefractionGunProjectile;
		%spread = 0.0022;
		%shellcount = 3;
	
		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector,(%projectile.muzzleVelocity+getRandom(-30,30)));
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				originPoint = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
		return %p;
	}
	else
	{
		%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-5")));
		
		%projectile = DefractionGunProjectile;
		%spread = 0.009;
		%shellcount = 9;

		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				originPoint = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};	
			MissionCleanup.add(%p);
		}
		return %p;	
	}
}

package DefractionGun
{
	function armor::onTrigger(%this,%player,%slot,%val)
	{
		if(%slot $= 4 && %player.getMountedImage(0) $= DefractionGunImage.getID())
		{
			if(%val)
			{
				%player.DefractionGunTrigEnable = getSimTime();
			}
			else
			{
				if(vectorDist(%player.DefractionGunTrigEnable,getSimTime()) < 500)
				{
					%player.setImageAmmo(0,0);
					%player.setImageTrigger(0,1);
					%player.setImageTrigger(0,0);
					%player.setImageAmmo(0,1);
				}
			}
		}
		else
			Parent::onTrigger(%this,%player,%slot,%val);
	}
};
ActivatePackage(DefractionGun);